<?php

namespace common\modules\triggers\controllers;

use common\components\BaseController;
use common\modules\triggers\components\conditions\Conditions;
use common\modules\triggers\models\TriggerLogs;
use common\modules\triggers\models\TriggerSchedule;
use common\modules\triggers\models\TriggerTrigger;
use \DateTime;
use yii\helpers\Json;

/**
 * Default controller for the `triggers` module
 */
class DefaultController extends BaseController
{
    public static function actionsTitles(){
        return [
            'Index' => 'Главная страница модуля',
            'Rechecktriggers' => 'Запуск проверки срабатывания триггеров',
            'Settimeoflogs' => 'Фиксация времени логов',
            'Inittrigger' => 'Initiate trigger By id'
        ];
    }

    /**
     * @param $id
     * @param $value
     */
    public function actionSettimeoflogs($id, $value)
    {
        /** @var TriggerLogs $model */
        $model = TriggerLogs::findOne($id);
        if (!is_null($model)) {
            $model->presence_time = $value;
            $model->save(false);
        }
    }

    public function actionInittrigger($id){
        if (\Yii::$app->request->isAjax) {
            /** @var TriggerTrigger $trigger */
            $trigger = TriggerTrigger::findOne($id);
            $trigger->initAction();
        }
    }

    /**
     * Renders the index view for the module
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Метод для крона и ручного вызова. Проверяет таблицу с расписанием, выполняет сработавшие триггеры.
     */
    public function actionRechecktriggers(){
        /** @var TriggerTrigger[] $actualTriggers */
        // Получили текущую дату и время
        $timeNow = new DateTime();
        // Получили все те сообщения которые еще не обработаны и имеют дату равную или меньше текущей
        /** @var TriggerSchedule[] $uncheckedArray */
        $uncheckedArray = TriggerSchedule::find()->where('time <= :time_now', [':time_now' => $timeNow->format('Y-m-d H:i:s')])->all();
        // Получили все актуальные триггеры в базе
        $actualTriggers = TriggerTrigger::getActualTriggers();
        // Перебираем эти сообщения в цикле
        foreach($uncheckedArray as $message) {
            $triggerIsUsed=false;
            // Проверяем каждое сообщение на срабатывание триггера
            foreach($actualTriggers as $trigger) {
                // Вызвали метод проверки срабатывания условий
                $triggerResult = Conditions::init()->handleMessageByTriggerId($message, $trigger->getPrimaryKey());
                // Если триггер сработал инициируем действие
                if ($triggerResult===true) {
                    $triggerIsUsed=true;
                    $init = $trigger->initAction(['email' => $message->email]);
                    if ($init!==true)
                        echo $init;
                }
            }
            if ($triggerIsUsed===true) {
                /** @var TriggerSchedule $model */
                $model=TriggerSchedule::findOne($message->getPrimaryKey());
                $model->checked=1;
                $model->save();
            }
        }
    }
}
